package com.ZoS.RoyalFlush.Console;

public abstract class Command {
	protected String name;
	protected String command;
	protected String helpMessage;
	protected int numParameters;
	protected String[] parameters;
	
	public Command(String _name, String _command, int _numParams, String _help) {
		this.name = _name;
		this.command = _command;
		this.numParameters = _numParams;
		this.helpMessage = _help;
	}
	
	public void execute(String[] _parameters) {
		this.parameters = _parameters;
		run();
	}
	
	//Getters
	public String getName() { return this.name; }
	public String getCommand() { return this.command; }
	public String getHelpMessage() { return this.helpMessage; }
	public int getNumParameters() { return this.numParameters; }
	public String[] getParameters() { return this.parameters; }
	
	//Overwrite for Commands
	public abstract void run();
	public abstract boolean runWithoutCheats();
}