package com.ZoS.RoyalFlush.Console;

import java.util.ArrayList;
import com.ZoS.RoyalFlush.Console.Commands.*;

public class Console {
	
	protected boolean open;
	protected boolean cheatsAllowed;
	protected ArrayList<Command> commands;
	
	public Console() {
		this.open = false;
		this.cheatsAllowed = false;
		this.commands = new ArrayList<Command>();
		
		//Add all the default engine commands
		this.addEngineCommands();
	}
	
	public void openConsole() {
		this.open = true;
	}
	
	public void closeConsole() {
		this.open = false;
	}
	
	public void toggle() {
		if(this.open){
			this.closeConsole();
		} else {
			this.openConsole();
		}
	}
	
	public void addCommand(Command _command) {
		if(!this.hasCommand(_command)) {
			this.commands.add(_command);
		}
	}
	
	public void removeCommand(Command _command) {
		this.commands.remove(_command);
	}
	
	public boolean hasCommand(Command _command) {
		if(this.commands.contains(_command)) {
			return true;
		} else {
			return false;
		}
	}
	
	public void runCommand() {
		
	}
	
	private void addEngineCommands() {
		this.addCommand(new CommandSVCheat());
		this.addCommand(new CommandHelp());
	}
	
	//Getters
	public boolean isOpen()				{ return this.open; }
	public boolean isClosed()			{ return !this.open; }
	public boolean isCheatingAllowed()	{ return this.cheatsAllowed; }
	
	//Setters
	public void setCheatingAllowed(boolean _cheating) {  this.cheatsAllowed = _cheating; }
}