package com.ZoS.RoyalFlush.GUI;

public final class Window {
	
	private int width					= 800;
	private int height					= 600;
	private float aspectRatio			= ((float)width / (float)height);
	private int x						= 0;
	private int y						= 0;
	private boolean fullscreen			= false;
	private boolean vSync				= false;
	private boolean isResizable			= false;
	private String title				= "RoyalFlush Window";
	private int maxFPS					= 60;
	
	public Window(int _width, int _height, boolean _fullscreen, boolean _vsync, String _title) {
		this.width = _width;
		this.height = _height;
		this.fullscreen = _fullscreen;
		this.vSync = _vsync;
		this.title = _title;
		this.updateAspectRatio();
	}

	/*************************************************************************/
	
	public int getWidth() {
		return this.width;
	}
	
	public int getHeight() {
		return this.height;
	}
	
	//TODO: make this change based on aspect ratio
	public int getOrthoWidth() {
		return 800;
	}
	
	//TODO: make this change based on aspect ratio
	public int getOrthoHeight() {
		return 600;
	}
	
	public float getAspectRatio() {
		return this.aspectRatio;
	}
	
	public int getX() {
		return this.x;
	}
	
	public int getY() {
		return this.y;
	}
	
	public boolean isFullscreen() {
		return this.fullscreen;
	}
	
	public boolean getVSycn() {
		return this.vSync;
	}
	
	public boolean isResizable() {
		return this.isResizable;
	}
	
	public String getTitle() {
		return this.title;
	}
	
	public int getMaxFPS() {
		return this.maxFPS;
	}

	/*************************************************************************/
	
	protected void setHeight(int _height) {
		this.height = _height;
		updateAspectRatio();
	}
	
	protected void setWidth(int _width) {
		this.width = _width;
		updateAspectRatio();
	}
	
	protected void setWindowSize(int _width, int _height) {
		this.width = _width;
		this.height = _height;
		updateAspectRatio();
	}
	
	protected void setX(int _x) {
		this.x = _x;
	}
	
	protected void setY(int _y) {
		this.y = _y;
	}
	
	protected void setFullscreen(boolean _fullscreen) {
		this.fullscreen = _fullscreen;
	}
	
	protected void toggleFullscreen() {
		setFullscreen(!this.fullscreen);
	}
	
	protected void setVSync(boolean _vsync) {
		this.vSync = _vsync;
	}
	
	protected void toggleVSync() {
		setVSync(!this.vSync);
	}
	
	protected void setResizable(boolean _resizable) {
		this.isResizable = _resizable;
	}
	
	protected void toggleResizable() {
		setResizable(!this.isResizable);
	}
	
	protected void setTitle(String _title) {
		this.title = _title;
	}
	
	protected void setMaxFPS(int _maxFPS) {
		this.maxFPS = _maxFPS;
	}
	
	/*************************************************************************/
	
	private void updateAspectRatio() {
		this.aspectRatio = ((float)this.width / (float)this.height);
	}
}