package com.ZoS.RoyalFlush.Game;

import com.ZoS.RoyalFlush.Input.Keyboard;
import com.ZoS.RoyalFlush.Input.MouseCursor;

/**
 * A base class for a game using the Royal Flush engine.
 * 
 * @author JpDeathBlade
 */
public interface IGame {
	
	/**
	 * This method is called by RoyalFlushApplication to initialize the game and
	 * all its contents. 
	 * 
	 * @return TRUE if all goes well; FALSE will shutdown the application.
	 */
	public abstract boolean Initialize();
	
	/**
	 * 
	 * @return TRUE if all goes well; FALSE will shutdown the application lol.
	 */
	public abstract boolean Shutdown();
	
	/**
	 * 
	 * @param _deltaTime
	 * @return TRUE if all goes well; FALSE will shutdown the application.
	 */
	public abstract boolean Input(double _deltaTime, MouseCursor _mouse, Keyboard _keyboard);
	
	/**
	 * 
	 * @param _deltaTime
	 * @return TRUE if all goes well; FALSE will shutdown the application.
	 */
	public abstract boolean Update(double _deltaTime);
	
	/**
	 * 
	 * @param _deltaTime
	 * @return TRUE if all goes well; FALSE will shutdown the application.
	 */
	public abstract boolean Render3D(double _deltaTime);
	
	/**
	 * 
	 * @param _deltaTime
	 * @return TRUE if all goes well; FALSE will shutdown the application.
	 */
	public abstract boolean Render2D(double _deltaTime);
}