package com.ZoS.RoyalFlush.Renderer;

import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;

import com.ZoS.RoyalFlush.GUI.Window;

public final class OGLRenderer {
	private Window window;
	private float perspectiveFoV	= 60.0f;
	private float perspectiveZNear	= 0000.01f;
	private float perspectiveZFar	= 1000.00f;
	private float orthoZNear		= -1.0f;
	private float orthoZFar			= 10.0f;
	
	public OGLRenderer(Window _window) {
		this.window = _window;
	}
	
	//TODO: Nothing about this is init GL... Fix Name or what it does
	public void initGL() {
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glShadeModel(GL11.GL_SMOOTH);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glDepthFunc(GL11.GL_LEQUAL);
			
		GL11.glEnable(GL11.GL_CULL_FACE);
		GL11.glCullFace(GL11.GL_BACK);
			 
		GL11.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
		GL11.glClearDepth(1);
			 
		//TODO: Set up viewports for multiplayer games
		GL11.glViewport(0, 0, this.window.getWidth(), this.window.getHeight());
	}
	
	public void glSetup3D() {
		initGL();
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GLU.gluPerspective(perspectiveFoV, this.window.getAspectRatio(), perspectiveZNear, perspectiveZFar);

		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();

		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT | GL11.GL_STENCIL_BUFFER_BIT);
	}
	
	public void glSetup2D() {
		initGL();
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glOrtho(0.0, this.window.getOrthoWidth(), this.window.getOrthoHeight(), 0.0, orthoZNear, orthoZFar);

		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();

		GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT | GL11.GL_STENCIL_BUFFER_BIT);
	}
}